package hibernate;

import java.util.LinkedList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@Entity
@Table(name="beancontainer")
public class BeanContainer {
	private Long id;
	private List<SimpleBean> list;
	
	@Id
	@GeneratedValue
	public Long getId() {
		return id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}
	
	@OneToMany(cascade=CascadeType.ALL)
	public List<SimpleBean> getList() {
		return list;
	}

	public void setList(List<SimpleBean> list) {
		this.list = list;
	}

	public BeanContainer(){
		list = new LinkedList<SimpleBean>();
	}
	
	public void addBean(SimpleBean bean){
		list.add(bean);
	}
}
