package hibernate;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.persistence.Query;

public class HibernateStub {
	EntityManagerFactory factory;
    EntityManager manager;
	
    public void init() {
        factory = Persistence.createEntityManagerFactory("sep_sample");
        manager = factory.createEntityManager();
    }
    
    private void shutdown() {
        manager.close();
        factory.close();
    }
    
    public void create(){
    	EntityTransaction tx = manager.getTransaction();
        tx.begin();
        try {
       		BeanContainer b = new BeanContainer();
            SimpleBean s  = new SimpleBean();
            s.setText("Foo");
            SimpleBean s2  = new SimpleBean();
            s2.setText("Bar");
            b.addBean(s);
            b.addBean(s2);
       	 	manager.persist(b);
            tx.commit();
        } catch (Exception ex) {
            tx.rollback();
        }
    }
    
    @SuppressWarnings("unchecked")
	public void load(){
    	EntityTransaction tx = manager.getTransaction();
        tx.begin();
        try {
        	Query query = manager.createQuery("select b from BeanContainer b");
            List<BeanContainer> results = (List<BeanContainer>)query.getResultList();
            if(!results.isEmpty()){
            	for(BeanContainer b: results){
            		for(SimpleBean s: b.getList()){
            			System.out.print(s.getText() + " ");
            		}
            		System.out.println();
            	}
            }
            else System.out.println("No Objects retrieved from the database.");
            tx.commit();
        } catch (Exception ex) {
            tx.rollback();
        }
    }
    
	public static void main(String[] args){
		HibernateStub main = new HibernateStub();
	 	System.out.println("EJB3 persistence demo");
        main.init();
        try {
        	main.create();
        	main.load();
        } catch (RuntimeException ex) {
            ex.printStackTrace();
        } finally {
            main.shutdown();
        }
	}
	
}
